#include "IVG/resources.hlsl"
#include "ShaderConstants.fxh"
#include "util.fxh"
struct PS_Input
{float4 position : SV_Position;
#ifndef BYPASS_PIXEL_SHADER
lpfloat4 color : COLOR; snorm float2 uv0 : TEXCOORD_0_FB_MSAA; snorm float2 uv1 : TEXCOORD_1_FB_MSAA; 	float3	IVGWPos : WIVG; float3 wpos : WPOS; 
#endif
#ifdef FOG
float4 fogColor : FOG_COLOR;
#endif
};
struct PS_Output
{float4 color : SV_Target;};
ROOT_SIGNATURE
void main(in PS_Input PSInput, out PS_Output PSOutput){
#ifdef BYPASS_PIXEL_SHADER
PSOutput.color = float4(0.0f, 0.0f, 0.0f, 0.0f); return;
#else
#if USE_TEXEL_AA
float4 diffuse = texture2D_AA(TEXTURE_0, TextureSampler0, PSInput.uv0 );
#else
float4 diffuse = TEXTURE_0.Sample(TextureSampler0, PSInput.uv0);
#endif
#ifdef SEASONS_FAR
diffuse.a = 1.0f;
#endif
#if USE_ALPHA_TEST
#ifdef ALPHA_TO_COVERAGE
#define ALPHA_THRESHOLD 0.05
#else
#define ALPHA_THRESHOLD 0.5
#endif
if(diffuse.a < ALPHA_THRESHOLD) discard;
#endif
#define vec3 float3
#define mix lerp
float RDet = 1.0-pow(FOG_CONTROL.y, 11.0);
bool cave = smoothstep(0.5,0.0, PSInput.uv1.y);
bool greenPlant = (PSInput.color.g + PSInput.color.g > PSInput.color.r + PSInput.color.b);
bool water = (PSInput.color.b > PSInput.color.r);
bool sunSet = (FOG_COLOR.r*1.0>FOG_COLOR.b);
bool nether = (FOG_COLOR.r > FOG_COLOR.b && FOG_COLOR.r < 0.5 && FOG_COLOR.b < 0.05);
bool night = (FOG_COLOR.r<0.15 && FOG_COLOR.g<0.15);
bool TheEnd = (FOG_COLOR.r > FOG_COLOR.g && FOG_COLOR.b > FOG_COLOR.g && FOG_COLOR.r < 0.05 && FOG_COLOR.b < 0.05);
bool inRain = (FOG_CONTROL.x < 0.55 && FOG_CONTROL.x > 0.1);
bool Underwater = (FOG_COLOR.b >= FOG_COLOR.r * 1.8 && FOG_COLOR.g > FOG_COLOR.r * 1.5  && FOG_COLOR.b >= FOG_COLOR.g * 1.1 && FOG_COLOR.b > 0.15);
#if defined(BLEND)
diffuse.a *= PSInput.color.a;
#endif
#if !defined(ALWAYS_LIT)
diffuse = diffuse * TEXTURE_1.Sample(TextureSampler1, PSInput.uv1);
#endif
#ifndef SEASONS
#if !USE_ALPHA_TEST && !defined(BLEND)
diffuse.a = PSInput.color.a;
#endif	
diffuse.rgb *= PSInput.color.rgb;
#else
float2 uv = PSInput.color.xy; diffuse.rgb *= lerp(1.0f, TEXTURE_2.Sample(TextureSampler2, uv).rgb*2.0f, PSInput.color.b); diffuse.rgb *= PSInput.color.aaa; diffuse.a = 1.0f;
#endif
float wetFX = length(PSInput.wpos.xyz)/RENDER_DISTANCE;
float IVGwe2 = sin(TIME*3.6+PSInput.IVGWPos.x+PSInput.IVGWPos.z+PSInput.IVGWPos.x+PSInput.IVGWPos.z+PSInput.IVGWPos.y)*sin(PSInput.IVGWPos.z)*0.08;
float IVGwe = cos(noise(float2(TIME*1.5+PSInput.IVGWPos.x+PSInput.IVGWPos.y+PSInput.IVGWPos.z+PSInput.IVGWPos.y*2.0,TIME*1.2+PSInput.IVGWPos.x+PSInput.IVGWPos.x+PSInput.IVGWPos.z+PSInput.IVGWPos.y*1.1+PSInput.IVGWPos.x+PSInput.IVGWPos.z+PSInput.IVGWPos.x*1.0)));
if(inRain==true){if(nether==false){
if(frac(PSInput.IVGWPos.y)==0.0){
diffuse.rgb += clamp(wetFX*7.5,0.0,0.3)*RDet;}
if(frac(PSInput.IVGWPos.y)==0.5){
diffuse.rgb += clamp(wetFX*7.5,0.0,0.3)*RDet;}}}
vec3 dirb = normalize(cross(ddx(PSInput.IVGWPos), ddy(PSInput.IVGWPos)));
if(nether==false){if(night==true){diffuse.rgb = saturation(diffuse.rgb, 0.3);}}
if(nether==true){diffuse.rgb = saturation(diffuse.rgb, 0.2);}
if(nether==false){if(cave==false){float directionalL = max(0.0, max(dirb.z, -dirb.z)); diffuse.rgb *= mix(1.0,0.37,directionalL);}}
diffuse.rgb = saturation(diffuse.rgb, 1.1);
vec3 IVGFOGPOG = mix(diffuse.rgb, FOG_COLOR.rgb, clamp(length(-PSInput.wpos)/RENDER_DISTANCE*0.7,0.01,0.3)); diffuse.rgb = IVGFOGPOG;
float Lightamt = (((0.2*4+(0.1*2))-1.0)+(0.5*((0.5*2)*2)));
if(inRain==true){vec3 IVGfogR = lerp(diffuse.rgb, FOG_COLOR.rgb, clamp(length(-PSInput.wpos)/RENDER_DISTANCE*1.0,0.1,0.6)); diffuse.rgb = IVGfogR;}
diffuse.rgb *= vec3(1.6,1.4,1.0);
float shIVG = mix(0.55,1.0,smoothstep(0.855,0.873,PSInput.uv1.y)); diffuse.rgb *= mix(shIVG,Lightamt,PSInput.uv1.x);
diffuse.rgb += vec3(1,0.45,0)*max(PSInput.uv1.x-0.5,0.0)*(1.0-diffuse.rgb);
diffuse.rgb = TMap(diffuse.rgb);
if(nether==true){diffuse.rgb *= vec3(0.8,0.55,0.55); diffuse.rgb+=diffuse.rgb*(vec3(.7,.4,-1.2)*2.0)*pow(PSInput.uv1.x*1.0,4.0); float3 IVGfogN = lerp(diffuse.rgb, FOG_COLOR.rgb*float3(1.5,.0,.0), clamp(length(-PSInput.wpos)/FAR_CHUNKS_DISTANCE*1.0,0.1,0.6)); diffuse.rgb = IVGfogN;}
if(TheEnd==true){vec3 IVGfogE = lerp(diffuse.rgb, FOG_COLOR.rgb*vec3(2.72,.0,3.0), clamp(length(-PSInput.wpos)/FAR_CHUNKS_DISTANCE*1.0,0.1,0.6)); diffuse.rgb = IVGfogE;}
if(Underwater==true){diffuse.rgb *= vec3(0.0,1.35,1.9); diffuse.rgb += diffuse.rgb*(vec3(-1.2,0.0,1.6)*1.95)*pow(PSInput.uv1.x*1.1,4.0);}
if(nether==false){if(FOG_CONTROL.x==0.0){diffuse.rgb = float4(vec3(0.0,1.0,1.3),0.0)*diffuse+(10.0,IVGwe2)*float4(float3(0.0,1.0,1.3)*1.2,.0)*float3(0.0,1.0,1.3);}}
#ifdef BLEND
diffuse.a *= float(0.56);
#ifdef FANCY
if(water==true){diffuse.rgb += noise(PSInput.IVGWPos*0.5*abs(IVGwe))*0.42;
diffuse.rgb += IVGwe*float(0.2);
diffuse.rgb *= mix(float(0.8),float(0.7),(IVGwe));
if(sunSet==false){diffuse.rgb = saturation(diffuse.rgb, 0.46);}
if(sunSet==true){diffuse.rgb *= FOG_COLOR.rgb;}}
#else
if(water==true){
diffuse.rgb = float4(float3(1.0,1.0,1.0),0.0)*diffuse+(10.0,IVGwe2)*float4(float3(1.0,1.0,1.0)*1.2,.0)*float3(1.0,1.0,1.0);
diffuse.a *= float(1.0);}
#endif
if(sunSet==true){
diffuse.rgb += clamp(1.0-length(-PSInput.wpos.z*10.0)/RENDER_DISTANCE*1.0,0.0,1.0)*float3(2.0,1.5,0.05)*length(-PSInput.wpos.x)/RENDER_DISTANCE*1.0;}
#endif
#ifdef FOG
diffuse.rgb = mix( diffuse.rgb, PSInput.fogColor.rgb, PSInput.fogColor.a );
#endif
PSOutput.color = diffuse;
#ifdef VR_MODE
PSOutput.color = max(PSOutput.color,1/255.0f);
#endif
#endif // BYPASS_PIXEL_SHADER
}
///    PXD    ///
///IVG shader///
