#include "ShaderConstants.fxh"
struct VS_Input
{float3 position : POSITION; float4 color : COLOR;
#ifdef INSTANCEDSTEREO
uint instanceID : SV_InstanceID;
#endif
};
struct PS_Input
{float4 position : SV_Position; float4 color : COLOR;
#ifdef GEOMETRY_INSTANCEDSTEREO
uint instanceID : SV_InstanceID;
#endif
#ifdef VERTEXSHADER_INSTANCEDSTEREO
uint renTarget_id : SV_RenderTargetArrayIndex;
#endif
};
ROOT_SIGNATURE
void main(in VS_Input VSInput, out PS_Input PSInput){
float4 VSpos1 = float4(VSInput.position,1.0); VSpos1.y -= length(VSpos1.xz); float2 pos = VSInput.position.xz; float fog = VSInput.color.r; float4 cclr = CURRENT_COLOR; float4 fgclr = FOG_COLOR; float4 VSclr = VSInput.color; float fog_flag = 0.0; float3 day = float3(0.5,0.5,0.69); float3 rain = float3(2.5,2.5,2.52); float3 night = float3(0.1, 0.43, 0.58) * 0.5;
#ifdef INSTANCEDSTEREO
int i = VSInput.instanceID; PSInput.position = mul( WORLDVIEWPROJ_STEREO[i], VSpos1);
#else
PSInput.position = mul(WORLDVIEWPROJ,VSpos1);
#endif
#ifdef GEOMETRY_INSTANCEDSTEREO
PSInput.instanceID = VSInput.instanceID;
#endif 
#ifdef VERTEXSHADER_INSTANCEDSTEREO
PSInput.renTarget_id = VSInput.instanceID;
#endif
PSInput.color = lerp( CURRENT_COLOR, FOG_COLOR, VSInput.color.r );	
if(FOG_CONTROL.x < 0.55 && FOG_CONTROL.x > 0.1){fog_flag = 0.0; cclr.rgb = max(cclr.rgb * rain, night); PSInput.color = lerp(cclr, fgclr, VSclr.r);} cclr.rgb = max(cclr.rgb * day, night); fgclr.rgb = max(fgclr.rgb * 10.0, 0.0); if(fog_flag == 0.0){PSInput.color = lerp(cclr, fgclr, VSclr.r);}}